diff -up ./lib/pk11wrap/pk11akey.c.mlkem ./lib/pk11wrap/pk11akey.c
--- ./lib/pk11wrap/pk11akey.c.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/pk11wrap/pk11akey.c	2024-10-18 11:20:24.043115706 -0700
@@ -235,12 +235,17 @@ PK11_ImportPublicKey(PK11SlotInfo *slot,
                 }
                 break;
             case kyberKey:
-                keyType = CKK_NSS_KYBER;
                 switch (pubKey->u.kyber.params) {
                     case params_kyber768_round3:
                     case params_kyber768_round3_test_mode:
+                        keyType = CKK_NSS_KYBER;
                         kemParams = CKP_NSS_KYBER_768_ROUND3;
                         break;
+                    case params_ml_kem768:
+                    case params_ml_kem768_test_mode:
+                        keyType = CKK_NSS_ML_KEM;
+                        kemParams = CKP_NSS_ML_KEM_768;
+                        break;
                     default:
                         kemParams = CKP_INVALID_ID;
                         break;
@@ -661,6 +666,7 @@ PK11_ExtractPublicKey(PK11SlotInfo *slot
                 keyType = edKey;
                 break;
             case CKK_NSS_KYBER:
+            case CKK_NSS_ML_KEM:
                 keyType = kyberKey;
                 break;
             default:
@@ -832,7 +838,12 @@ PK11_ExtractPublicKey(PK11SlotInfo *slot
             if (crv != CKR_OK)
                 break;
 
-            if ((keyClass != CKO_PUBLIC_KEY) || (pk11KeyType != CKK_NSS_KYBER)) {
+            if (keyClass != CKO_PUBLIC_KEY) {
+                crv = CKR_OBJECT_HANDLE_INVALID;
+                break;
+            }
+
+            if (pk11KeyType != CKK_NSS_KYBER && pk11KeyType != CKK_NSS_ML_KEM) {
                 crv = CKR_OBJECT_HANDLE_INVALID;
                 break;
             }
@@ -846,6 +857,9 @@ PK11_ExtractPublicKey(PK11SlotInfo *slot
                 case CKP_NSS_KYBER_768_ROUND3:
                     pubKey->u.kyber.params = params_kyber768_round3;
                     break;
+                case CKP_NSS_ML_KEM_768:
+                    pubKey->u.kyber.params = params_ml_kem768;
+                    break;
                 default:
                     pubKey->u.kyber.params = params_kyber_invalid;
                     break;
@@ -909,6 +923,7 @@ PK11_MakePrivKey(PK11SlotInfo *slot, Key
                 keyType = edKey;
                 break;
             case CKK_NSS_KYBER:
+            case CKK_NSS_ML_KEM:
                 keyType = kyberKey;
                 break;
             default:
@@ -1525,6 +1540,17 @@ PK11_GenerateKeyPairWithOpFlags(PK11Slot
             keyType = kyberKey;
             test_mech.mechanism = CKM_NSS_KYBER;
             break;
+        case CKM_NSS_ML_KEM_KEY_PAIR_GEN:
+            kemParams = (CK_NSS_KEM_PARAMETER_SET_TYPE *)param;
+            attrs = kyberPubTemplate;
+            PK11_SETATTRS(attrs, CKA_NSS_PARAMETER_SET,
+                          kemParams,
+                          sizeof(CK_NSS_KEM_PARAMETER_SET_TYPE));
+            attrs++;
+            pubTemplate = kyberPubTemplate;
+            keyType = kyberKey;
+            test_mech.mechanism = CKM_NSS_ML_KEM;
+            break;
         case CKM_EC_EDWARDS_KEY_PAIR_GEN:
             ecParams = (SECKEYECParams *)param;
             attrs = ecPubTemplate;
diff -up ./lib/pk11wrap/pk11mech.c.mlkem ./lib/pk11wrap/pk11mech.c
--- ./lib/pk11wrap/pk11mech.c.mlkem	2024-10-18 11:20:24.027115543 -0700
+++ ./lib/pk11wrap/pk11mech.c	2024-10-18 11:20:24.044115717 -0700
@@ -431,6 +431,8 @@ PK11_GetKeyType(CK_MECHANISM_TYPE type,
             return CKK_GENERIC_SECRET;
         case CKM_NSS_KYBER_KEY_PAIR_GEN:
             return CKK_NSS_KYBER;
+        case CKM_NSS_ML_KEM_KEY_PAIR_GEN:
+            return CKK_NSS_ML_KEM;
         default:
             return pk11_lookup(type)->keyType;
     }
diff -up ./lib/pk11wrap/pk11pars.c.mlkem ./lib/pk11wrap/pk11pars.c
--- ./lib/pk11wrap/pk11pars.c.mlkem	2024-10-18 11:20:24.019115461 -0700
+++ ./lib/pk11wrap/pk11pars.c	2024-10-18 11:20:24.044115717 -0700
@@ -247,6 +247,10 @@ static const oidValDef curveOptList[] =
       NSS_USE_ALG_IN_SSL_KX | NSS_USE_ALG_IN_CERT_SIGNATURE },
     { CIPHER_NAME("XYBER768D00"), SEC_OID_XYBER768D00, 
       NSS_USE_ALG_IN_SSL_KX },
+    { CIPHER_NAME("MLKEM768X25519"), SEC_OID_MLKEM768X25519, 
+      NSS_USE_ALG_IN_SSL_KX },
+    { CIPHER_NAME("MLKEM768SECP256R1"), SEC_OID_MLKEM768SECP256R1, 
+      NSS_USE_ALG_IN_SSL_KX },
     /* ANSI X9.62 named elliptic curves (characteristic two field) */
     { CIPHER_NAME("C2PNB163V1"), SEC_OID_ANSIX962_EC_C2PNB163V1,
       NSS_USE_ALG_IN_SSL_KX | NSS_USE_ALG_IN_CERT_SIGNATURE },
diff -up ./lib/pk11wrap/pk11skey.c.mlkem ./lib/pk11wrap/pk11skey.c
--- ./lib/pk11wrap/pk11skey.c.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/pk11wrap/pk11skey.c	2024-10-18 11:20:24.044115717 -0700
@@ -3083,6 +3083,8 @@ pk11_KyberCiphertextLength(SECKEYKyberPu
     switch (pubKey->params) {
         case params_kyber768_round3:
         case params_kyber768_round3_test_mode:
+        case params_ml_kem768:
+        case params_ml_kem768_test_mode:
             return KYBER768_CIPHERTEXT_BYTES;
         default:
             // unreachable
@@ -3135,16 +3137,18 @@ PK11_Encapsulate(SECKEYPublicKey *pubKey
     *outCiphertext = NULL;
 
     CK_MECHANISM_TYPE kemType;
-    switch (pubKey->keyType) {
-        case kyberKey:
+    CK_NSS_KEM_PARAMETER_SET_TYPE kemParameterSet = PK11_ReadULongAttribute(slot, pubKey->pkcs11ID, CKA_NSS_PARAMETER_SET);
+    switch (kemParameterSet) {
+        case CKP_NSS_KYBER_768_ROUND3:
             kemType = CKM_NSS_KYBER;
             break;
+        case CKP_NSS_ML_KEM_768:
+            kemType = CKM_NSS_ML_KEM;
+            break;
         default:
-            PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+            PORT_SetError(SEC_ERROR_INVALID_KEY);
             return SECFailure;
     }
-
-    CK_NSS_KEM_PARAMETER_SET_TYPE kemParameterSet = PK11_ReadULongAttribute(slot, pubKey->pkcs11ID, CKA_NSS_PARAMETER_SET);
     CK_MECHANISM mech = { kemType, &kemParameterSet, sizeof(kemParameterSet) };
 
     sharedSecret = pk11_CreateSymKey(slot, target, PR_TRUE, PR_TRUE, NULL);
@@ -3238,16 +3242,18 @@ PK11_Decapsulate(SECKEYPrivateKey *privK
     *outKey = NULL;
 
     CK_MECHANISM_TYPE kemType;
-    switch (privKey->keyType) {
-        case kyberKey:
+    CK_NSS_KEM_PARAMETER_SET_TYPE kemParameterSet = PK11_ReadULongAttribute(slot, privKey->pkcs11ID, CKA_NSS_PARAMETER_SET);
+    switch (kemParameterSet) {
+        case CKP_NSS_KYBER_768_ROUND3:
             kemType = CKM_NSS_KYBER;
             break;
+        case CKP_NSS_ML_KEM_768:
+            kemType = CKM_NSS_ML_KEM;
+            break;
         default:
-            PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+            PORT_SetError(SEC_ERROR_INVALID_KEY);
             return SECFailure;
     }
-
-    CK_NSS_KEM_PARAMETER_SET_TYPE kemParameterSet = PK11_ReadULongAttribute(slot, privKey->pkcs11ID, CKA_NSS_PARAMETER_SET);
     CK_MECHANISM mech = { kemType, &kemParameterSet, sizeof(kemParameterSet) };
 
     sharedSecret = pk11_CreateSymKey(slot, target, PR_TRUE, PR_TRUE, NULL);
diff -up ./lib/pk11wrap/secmodti.h.mlkem ./lib/pk11wrap/secmodti.h
--- ./lib/pk11wrap/secmodti.h.mlkem	2024-10-18 11:20:24.007115339 -0700
+++ ./lib/pk11wrap/secmodti.h	2024-10-18 11:20:24.044115717 -0700
@@ -207,5 +207,6 @@ struct PK11GenericObjectStr {
  * header file that only NSS sees. Currently it's only available through
  * the policy code */
 #define SEC_OID_TLS_REQUIRE_EMS SEC_OID_PRIVATE_1
+#define SEC_OID_MLKEM768SECP256R1 SEC_OID_PRIVATE_2
 
 #endif /* _SECMODTI_H_ */
diff -up ./lib/softoken/kem.c.mlkem ./lib/softoken/kem.c
--- ./lib/softoken/kem.c.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/softoken/kem.c	2024-10-18 11:20:24.044115717 -0700
@@ -6,6 +6,7 @@
 #include "kem.h"
 #include "pkcs11i.h"
 #include "pkcs11n.h"
+#include "secerr.h"
 #include "secitem.h"
 #include "secport.h"
 #include "softoken.h"
@@ -14,8 +15,8 @@ KyberParams
 sftk_kyber_PK11ParamToInternal(CK_NSS_KEM_PARAMETER_SET_TYPE pk11ParamSet)
 {
     switch (pk11ParamSet) {
-        case CKP_NSS_KYBER_768_ROUND3:
-            return params_kyber768_round3;
+        case CKP_NSS_ML_KEM_768:
+            return params_ml_kem768;
         default:
             return params_kyber_invalid;
     }
@@ -27,6 +28,8 @@ sftk_kyber_AllocPubKeyItem(KyberParams p
     switch (params) {
         case params_kyber768_round3:
         case params_kyber768_round3_test_mode:
+        case params_ml_kem768:
+        case params_ml_kem768_test_mode:
             return SECITEM_AllocItem(NULL, pubkey, KYBER768_PUBLIC_KEY_BYTES);
         default:
             return NULL;
@@ -39,6 +42,8 @@ sftk_kyber_AllocPrivKeyItem(KyberParams
     switch (params) {
         case params_kyber768_round3:
         case params_kyber768_round3_test_mode:
+        case params_ml_kem768:
+        case params_ml_kem768_test_mode:
             return SECITEM_AllocItem(NULL, privkey, KYBER768_PRIVATE_KEY_BYTES);
         default:
             return NULL;
@@ -51,6 +56,8 @@ sftk_kyber_AllocCiphertextItem(KyberPara
     switch (params) {
         case params_kyber768_round3:
         case params_kyber768_round3_test_mode:
+        case params_ml_kem768:
+        case params_ml_kem768_test_mode:
             return SECITEM_AllocItem(NULL, ciphertext, KYBER768_CIPHERTEXT_BYTES);
         default:
             return NULL;
@@ -64,7 +71,7 @@ sftk_kyber_ValidateParams(const CK_NSS_K
         return PR_FALSE;
     }
     switch (*params) {
-        case CKP_NSS_KYBER_768_ROUND3:
+        case CKP_NSS_ML_KEM_768:
             return PR_TRUE;
         default:
             return PR_FALSE;
@@ -78,7 +85,7 @@ sftk_kem_ValidateMechanism(CK_MECHANISM_
         return PR_FALSE;
     }
     switch (pMechanism->mechanism) {
-        case CKM_NSS_KYBER:
+        case CKM_NSS_ML_KEM:
             return pMechanism->ulParameterLen == sizeof(CK_NSS_KEM_PARAMETER_SET_TYPE) && sftk_kyber_ValidateParams(pMechanism->pParameter);
         default:
             return PR_FALSE;
@@ -88,14 +95,17 @@ sftk_kem_ValidateMechanism(CK_MECHANISM_
 static CK_ULONG
 sftk_kem_CiphertextLen(CK_MECHANISM_PTR pMechanism)
 {
-    /* Assumes pMechanism has been validated with sftk_kem_ValidateMechanism */
-    if (pMechanism->mechanism != CKM_NSS_KYBER) {
+#ifdef DEBUG
+    if (!sftk_kem_ValidateMechanism(pMechanism)) {
         PORT_Assert(0);
         return 0;
     }
+#endif
+
+    /* Assumes pMechanism has been validated with sftk_kem_ValidateMechanism */
     CK_NSS_KEM_PARAMETER_SET_TYPE *pParameterSet = pMechanism->pParameter;
     switch (*pParameterSet) {
-        case CKP_NSS_KYBER_768_ROUND3:
+        case CKP_NSS_ML_KEM_768:
             return KYBER768_CIPHERTEXT_BYTES;
         default:
             /* unreachable if pMechanism has been validated */
@@ -186,13 +196,13 @@ NSC_Encapsulate(CK_SESSION_HANDLE hSessi
     SECItem secret = { siBuffer, secretBuf, sizeof secretBuf };
 
     switch (pMechanism->mechanism) {
-        case CKM_NSS_KYBER: {
+        case CKM_NSS_ML_KEM:
             PORT_Assert(secret.len == KYBER_SHARED_SECRET_BYTES);
             CK_NSS_KEM_PARAMETER_SET_TYPE *pParameter = pMechanism->pParameter;
             KyberParams kyberParams = sftk_kyber_PK11ParamToInternal(*pParameter);
             SECStatus rv = Kyber_Encapsulate(kyberParams, /* seed */ NULL, &pubKey, &ciphertext, &secret);
             if (rv != SECSuccess) {
-                crv = CKR_FUNCTION_FAILED;
+                crv = (PORT_GetError() == SEC_ERROR_INVALID_ARGS) ? CKR_ARGUMENTS_BAD : CKR_FUNCTION_FAILED;
                 goto cleanup;
             }
 
@@ -210,7 +220,6 @@ NSC_Encapsulate(CK_SESSION_HANDLE hSessi
             *phKey = key->handle;
             *pulCiphertextLen = ciphertext.len;
             break;
-        }
         default:
             crv = CKR_MECHANISM_INVALID;
             goto cleanup;
@@ -316,13 +325,13 @@ NSC_Decapsulate(CK_SESSION_HANDLE hSessi
     SECItem secret = { siBuffer, secretBuf, sizeof secretBuf };
 
     switch (pMechanism->mechanism) {
-        case CKM_NSS_KYBER: {
+        case CKM_NSS_ML_KEM:
             PORT_Assert(secret.len == KYBER_SHARED_SECRET_BYTES);
             CK_NSS_KEM_PARAMETER_SET_TYPE *pParameter = pMechanism->pParameter;
             KyberParams kyberParams = sftk_kyber_PK11ParamToInternal(*pParameter);
             SECStatus rv = Kyber_Decapsulate(kyberParams, &privKey, &ciphertext, &secret);
             if (rv != SECSuccess) {
-                crv = CKR_FUNCTION_FAILED;
+                crv = (PORT_GetError() == SEC_ERROR_INVALID_ARGS) ? CKR_ARGUMENTS_BAD : CKR_FUNCTION_FAILED;
                 goto cleanup;
             }
 
@@ -337,7 +346,6 @@ NSC_Decapsulate(CK_SESSION_HANDLE hSessi
             }
             *phKey = key->handle;
             break;
-        }
         default:
             crv = CKR_MECHANISM_INVALID;
             goto cleanup;
diff -up ./lib/softoken/pkcs11c.c.mlkem ./lib/softoken/pkcs11c.c
--- ./lib/softoken/pkcs11c.c.mlkem	2024-10-18 11:20:24.033115604 -0700
+++ ./lib/softoken/pkcs11c.c	2024-10-18 11:20:24.045115727 -0700
@@ -5825,8 +5825,12 @@ NSC_GenerateKeyPair(CK_SESSION_HANDLE hS
             break;
 
         case CKM_NSS_KYBER_KEY_PAIR_GEN:
+            crv = CKR_MECHANISM_INVALID;
+            break;
+
+        case CKM_NSS_ML_KEM_KEY_PAIR_GEN:
             sftk_DeleteAttributeType(privateKey, CKA_NSS_DB);
-            key_type = CKK_NSS_KYBER;
+            key_type = CKK_NSS_ML_KEM;
 
             SECItem privKey = { siBuffer, NULL, 0 };
             SECItem pubKey = { siBuffer, NULL, 0 };
@@ -6009,7 +6013,7 @@ NSC_GenerateKeyPair(CK_SESSION_HANDLE hS
                                   &cktrue, sizeof(CK_BBOOL));
     }
 
-    if (crv == CKR_OK && key_type != CKK_NSS_KYBER) {
+    if (crv == CKR_OK && key_type != CKK_NSS_ML_KEM) {
         /* Perform FIPS 140-2 pairwise consistency check. */
         crv = sftk_PairwiseConsistencyCheck(hSession, slot,
                                             publicKey, privateKey, key_type);
diff -up ./lib/softoken/pkcs11.c.mlkem ./lib/softoken/pkcs11.c
--- ./lib/softoken/pkcs11.c.mlkem	2024-10-18 11:20:24.033115604 -0700
+++ ./lib/softoken/pkcs11.c	2024-10-18 11:20:24.045115727 -0700
@@ -648,9 +648,9 @@ static const struct mechanismList mechan
     { CKM_NSS_IKE_PRF_DERIVE, { 8, 64, CKF_DERIVE }, PR_TRUE },
     { CKM_NSS_IKE1_PRF_DERIVE, { 8, 64, CKF_DERIVE }, PR_TRUE },
     { CKM_NSS_IKE1_APP_B_PRF_DERIVE, { 8, 255 * 64, CKF_DERIVE }, PR_TRUE },
-    /* -------------------- Kyber Operations ----------------------- */
-    { CKM_NSS_KYBER_KEY_PAIR_GEN, { 0, 0, CKF_GENERATE_KEY_PAIR }, PR_TRUE },
-    { CKM_NSS_KYBER, { 0, 0, 0 }, PR_TRUE },
+    /* -------------------- ML KEM Operations ----------------------- */
+    { CKM_NSS_ML_KEM_KEY_PAIR_GEN, { 0, 0, CKF_GENERATE_KEY_PAIR }, PR_TRUE },
+    { CKM_NSS_ML_KEM, { 0, 0, 0 }, PR_TRUE },
 };
 static const CK_ULONG mechanismCount = sizeof(mechanisms) / sizeof(mechanisms[0]);
 
@@ -1096,6 +1096,7 @@ sftk_handlePublicKeyObject(SFTKSession *
             wrap = CK_FALSE;
             break;
         case CKK_NSS_KYBER:
+        case CKK_NSS_ML_KEM:
             if (!sftk_hasAttribute(object, CKA_NSS_PARAMETER_SET)) {
                 return CKR_TEMPLATE_INCOMPLETE;
             }
@@ -1309,6 +1310,7 @@ sftk_handlePrivateKeyObject(SFTKSession
             createObjectInfo = PR_FALSE;
             break;
         case CKK_NSS_KYBER:
+        case CKK_NSS_ML_KEM:
             if (!sftk_hasAttribute(object, CKA_KEY_TYPE)) {
                 return CKR_TEMPLATE_INCOMPLETE;
             }
@@ -2002,6 +2004,7 @@ sftk_GetPubKey(SFTKObject *object, CK_KE
             }
             break;
         case CKK_NSS_KYBER:
+        case CKK_NSS_ML_KEM:
             crv = CKR_OK;
             break;
         default:
@@ -2160,6 +2163,7 @@ sftk_mkPrivKey(SFTKObject *object, CK_KE
             break;
 
         case CKK_NSS_KYBER:
+        case CKK_NSS_ML_KEM:
             break;
 
         default:
diff -up ./lib/ssl/sslimpl.h.mlkem ./lib/ssl/sslimpl.h
--- ./lib/ssl/sslimpl.h.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/ssl/sslimpl.h	2024-10-18 11:20:24.045115727 -0700
@@ -130,7 +130,7 @@ typedef enum { SSLAppOpRead = 0,
 #define DTLS_RETRANSMIT_FINISHED_MS 30000
 
 /* default number of entries in namedGroupPreferences */
-#define SSL_NAMED_GROUP_COUNT 32
+#define SSL_NAMED_GROUP_COUNT 33
 
 /* The maximum DH and RSA bit-length supported. */
 #define SSL_MAX_DH_KEY_BITS 8192
diff -up ./lib/ssl/sslsock.c.mlkem ./lib/ssl/sslsock.c
--- ./lib/ssl/sslsock.c.mlkem	2024-10-18 11:20:24.000115267 -0700
+++ ./lib/ssl/sslsock.c	2024-10-18 11:20:24.046115737 -0700
@@ -22,6 +22,7 @@
 #include "tls13ech.h"
 #include "tls13psk.h"
 #include "tls13subcerts.h"
+#include "secmodti.h" /* until SEC_OID_MLKEM768SECP256R1 is upstream */
 
 static const sslSocketOps ssl_default_ops = { /* No SSL. */
                                               ssl_DefConnect,
@@ -167,7 +168,8 @@ const sslNamedGroupDef ssl_named_groups[
     ECGROUP(secp256r1, 256, SECP256R1, PR_TRUE),
     ECGROUP(secp384r1, 384, SECP384R1, PR_TRUE),
     ECGROUP(secp521r1, 521, SECP521R1, PR_TRUE),
-    { ssl_grp_kem_xyber768d00, 256, ssl_kea_ecdh_hybrid, SEC_OID_XYBER768D00, PR_TRUE },
+    { ssl_grp_kem_mlkem768secp256r1, 256, ssl_kea_ecdh_hybrid, SEC_OID_MLKEM768SECP256R1, PR_TRUE },
+    { ssl_grp_kem_mlkem768x25519, 256, ssl_kea_ecdh_hybrid, SEC_OID_MLKEM768X25519, PR_TRUE },
     FFGROUP(2048),
     FFGROUP(3072),
     FFGROUP(4096),
diff -up ./lib/ssl/sslt.h.mlkem ./lib/ssl/sslt.h
--- ./lib/ssl/sslt.h.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/ssl/sslt.h	2024-10-18 11:20:24.046115737 -0700
@@ -260,7 +260,8 @@ typedef enum {
     ssl_grp_ffdhe_4096 = 258,
     ssl_grp_ffdhe_6144 = 259,
     ssl_grp_ffdhe_8192 = 260,
-    ssl_grp_kem_xyber768d00 = 25497, /* draft-tls-westerbaan-xyber768d00-02 */
+    ssl_grp_kem_mlkem768x25519 = 4588,
+    ssl_grp_kem_mlkem768secp256r1 = 4587,
     ssl_grp_none = 65537,            /* special value */
     ssl_grp_ffdhe_custom = 65538     /* special value */
 } SSLNamedGroup;
diff -up ./lib/ssl/tls13con.c.mlkem ./lib/ssl/tls13con.c
--- ./lib/ssl/tls13con.c.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/ssl/tls13con.c	2024-10-18 11:20:24.046115737 -0700
@@ -374,16 +374,24 @@ tls13_CreateKEMKeyPair(sslSocket *ss, co
                        sslKeyPair **outKeyPair)
 {
     PORT_Assert(groupDef);
-    if (groupDef->name != ssl_grp_kem_xyber768d00) {
-        PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
-        return SECFailure;
-    }
 
     sslKeyPair *keyPair = NULL;
     SECKEYPrivateKey *privKey = NULL;
     SECKEYPublicKey *pubKey = NULL;
-    CK_MECHANISM_TYPE mechanism = CKM_NSS_KYBER_KEY_PAIR_GEN;
-    CK_NSS_KEM_PARAMETER_SET_TYPE paramSet = CKP_NSS_KYBER_768_ROUND3;
+    CK_MECHANISM_TYPE mechanism;
+    CK_NSS_KEM_PARAMETER_SET_TYPE paramSet;
+
+    switch (groupDef->name) {
+        case ssl_grp_kem_mlkem768x25519:
+        case ssl_grp_kem_mlkem768secp256r1:
+            mechanism = CKM_NSS_ML_KEM_KEY_PAIR_GEN;
+            paramSet = CKP_NSS_ML_KEM_768;
+            break;
+        default:
+            PORT_Assert(0);
+            PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+            return SECFailure;
+    }
 
     PK11SlotInfo *slot = PK11_GetBestSlot(mechanism, ss->pkcs11PinArg);
     if (!slot) {
@@ -430,6 +438,48 @@ loser:
     return SECFailure;
 }
 
+/* only copy the ECDh component of an ephemeral KeyPair */
+sslEphemeralKeyPair *
+tls13_CopyDHEphemeralKeyPair(sslEphemeralKeyPair *copyKeyPair,
+                             const sslNamedGroupDef *groupDef) {
+    /* We could use ssl_CopyEphemeralKeyPair here, but we would need to free
+     * the KEM components. So we only copy the ECDH keys */
+    sslEphemeralKeyPair *keyPair = PORT_ZNew(sslEphemeralKeyPair);
+    if (!keyPair) {
+        return NULL;
+    }
+    PR_INIT_CLIST(&keyPair->link);
+    keyPair->group = groupDef;
+    keyPair->keys = ssl_GetKeyPairRef(copyKeyPair->keys);
+    return keyPair;
+}
+
+/*
+ * find a hybrid key Pair they might contain the same ecdh key so we
+ * can reuse them each ec group can map to more than one hybrid Pair
+ */
+sslEphemeralKeyPair *
+tls13_FindHybridKeyPair(sslSocket *ss, const sslNamedGroupDef *groupDef)
+{
+    sslEphemeralKeyPair *hybridPair = NULL;
+    switch (groupDef->name) {
+    case ssl_grp_ec_secp256r1:
+        /* future, this may be a loop to check multiple named groups */
+        hybridPair = ssl_LookupEphemeralKeyPair(ss,
+                     ssl_LookupNamedGroup(ssl_grp_kem_mlkem768secp256r1));
+        break;
+    case ssl_grp_ec_curve25519:
+        /* future, this will be a loop to check multiple named groups */
+        hybridPair = ssl_LookupEphemeralKeyPair(ss,
+                     ssl_LookupNamedGroup(ssl_grp_kem_mlkem768x25519));
+        break;
+    default:
+        return NULL;
+    }
+    return hybridPair;
+}
+
+
 SECStatus
 tls13_CreateKeyShare(sslSocket *ss, const sslNamedGroupDef *groupDef,
                      sslEphemeralKeyPair **outKeyPair)
@@ -437,24 +487,48 @@ tls13_CreateKeyShare(sslSocket *ss, cons
     SECStatus rv;
     const ssl3DHParams *params;
     sslEphemeralKeyPair *keyPair = NULL;
+    const sslNamedGroupDef *dhGroup = NULL;
 
     PORT_Assert(groupDef);
     switch (groupDef->keaType) {
         case ssl_kea_ecdh_hybrid:
-            if (groupDef->name != ssl_grp_kem_xyber768d00) {
+            switch (groupDef->name) {
+            case ssl_grp_kem_mlkem768secp256r1:
+                dhGroup = ssl_LookupNamedGroup(ssl_grp_ec_secp256r1);
+                break;
+            case ssl_grp_kem_mlkem768x25519:
+                dhGroup = ssl_LookupNamedGroup(ssl_grp_ec_curve25519);
+                break;
+            default:
                 PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
                 return SECFailure;
             }
-            rv = ssl_CreateECDHEphemeralKeyPair(ss, ssl_LookupNamedGroup(ssl_grp_ec_curve25519), &keyPair);
-            if (rv != SECSuccess) {
+            if (dhGroup == NULL) {
+                PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
                 return SECFailure;
             }
+            keyPair = ssl_LookupEphemeralKeyPair(ss, dhGroup);
+            if (keyPair) {
+                keyPair= ssl_CopyEphemeralKeyPair(keyPair);
+            }
+            if (!keyPair) {
+                rv = ssl_CreateECDHEphemeralKeyPair(ss, dhGroup, &keyPair);
+                if (rv != SECSuccess) {
+                    return SECFailure;
+                }
+            }
             keyPair->group = groupDef;
             break;
         case ssl_kea_ecdh:
-            rv = ssl_CreateECDHEphemeralKeyPair(ss, groupDef, &keyPair);
-            if (rv != SECSuccess) {
-                return SECFailure;
+            keyPair = tls13_FindHybridKeyPair(ss, groupDef);
+            if (keyPair) {
+                keyPair = tls13_CopyDHEphemeralKeyPair(keyPair, groupDef);
+            }
+            if (!keyPair) {
+                rv = ssl_CreateECDHEphemeralKeyPair(ss, groupDef, &keyPair);
+                if (rv != SECSuccess) {
+                    return SECFailure;
+                }
             }
             break;
         case ssl_kea_dh:
@@ -658,21 +732,45 @@ tls13_ImportKEMKeyShare(SECKEYPublicKey
 {
     SECItem pk = { siBuffer, NULL, 0 };
     SECStatus rv;
+    size_t expected_len;
 
-    if (entry->group->name != ssl_grp_kem_xyber768d00) {
-        PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
-        return SECFailure;
+    switch (entry->group->name) {
+        case ssl_grp_kem_mlkem768secp256r1:
+            expected_len = SECP256_PUBLIC_KEY_BYTES + KYBER768_PUBLIC_KEY_BYTES;
+            break;
+        case ssl_grp_kem_mlkem768x25519:
+            expected_len = X25519_PUBLIC_KEY_BYTES + KYBER768_PUBLIC_KEY_BYTES;
+            break;
+        default:
+            PORT_SetError(SEC_ERROR_UNSUPPORTED_KEYALG);
+            return SECFailure;
     }
 
-    if (entry->key_exchange.len != X25519_PUBLIC_KEY_BYTES + KYBER768_PUBLIC_KEY_BYTES) {
+    if (entry->key_exchange.len != expected_len) {
         PORT_SetError(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
         return SECFailure;
     }
-    pk.data = entry->key_exchange.data + X25519_PUBLIC_KEY_BYTES;
-    pk.len = entry->key_exchange.len - X25519_PUBLIC_KEY_BYTES;
 
-    peerKey->keyType = kyberKey;
-    peerKey->u.kyber.params = params_kyber768_round3;
+    switch (entry->group->name) {
+        case ssl_grp_kem_mlkem768secp256r1:
+            peerKey->keyType = kyberKey;
+            peerKey->u.kyber.params = params_ml_kem768;
+            /* key_exchange.data is `secp256 || mlkem768` */
+            pk.data = entry->key_exchange.data + SECP256_PUBLIC_KEY_BYTES;
+            pk.len = KYBER768_PUBLIC_KEY_BYTES;
+            break;
+        case ssl_grp_kem_mlkem768x25519:
+            peerKey->keyType = kyberKey;
+            peerKey->u.kyber.params = params_ml_kem768;
+            /* key_exchange.data is `mlkem768 || x25519` */
+            pk.data = entry->key_exchange.data;
+            pk.len = KYBER768_PUBLIC_KEY_BYTES;
+            break;
+        default:
+            PORT_Assert(0);
+            PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+            return SECFailure;
+    }
 
     rv = SECITEM_CopyItem(peerKey->arena, &peerKey->u.kyber.publicValue, &pk);
     if (rv != SECSuccess) {
@@ -690,13 +788,21 @@ tls13_HandleKEMCiphertext(sslSocket *ss,
     SECStatus rv;
 
     switch (entry->group->name) {
-        case ssl_grp_kem_xyber768d00:
+        case ssl_grp_kem_mlkem768secp256r1:
+            if (entry->key_exchange.len != SECP256_PUBLIC_KEY_BYTES + KYBER768_CIPHERTEXT_BYTES) {
+                ssl_MapLowLevelError(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
+                return SECFailure;
+            }
+            ct.data = entry->key_exchange.data + SECP256_PUBLIC_KEY_BYTES;
+            ct.len = KYBER768_CIPHERTEXT_BYTES;
+            break;
+        case ssl_grp_kem_mlkem768x25519:
             if (entry->key_exchange.len != X25519_PUBLIC_KEY_BYTES + KYBER768_CIPHERTEXT_BYTES) {
                 ssl_MapLowLevelError(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
                 return SECFailure;
             }
-            ct.data = entry->key_exchange.data + X25519_PUBLIC_KEY_BYTES;
-            ct.len = entry->key_exchange.len - X25519_PUBLIC_KEY_BYTES;
+            ct.data = entry->key_exchange.data;
+            ct.len = KYBER768_CIPHERTEXT_BYTES;
             break;
         default:
             PORT_Assert(0);
@@ -736,7 +842,7 @@ tls13_HandleKEMKey(sslSocket *ss,
         goto loser;
     }
 
-    PK11SlotInfo *slot = PK11_GetBestSlot(CKM_NSS_KYBER, ss->pkcs11PinArg);
+    PK11SlotInfo *slot = PK11_GetBestSlot(CKM_NSS_ML_KEM, ss->pkcs11PinArg);
     if (!slot) {
         goto loser;
     }
@@ -775,8 +881,11 @@ tls13_HandleKeyShare(sslSocket *ss,
     SECKEYPublicKey *peerKey;
     CK_MECHANISM_TYPE mechanism;
     PK11SymKey *key;
+    unsigned char *ec_data;
     SECStatus rv;
     int keySize = 0;
+    const sslNamedGroupDef *dhGroup = NULL;
+    int dhLen = 0;
 
     PORT_InitCheapArena(&arena, DER_DEFAULT_CHUNKSIZE);
     peerKey = PORT_ArenaZNew(&arena.arena, SECKEYPublicKey);
@@ -789,14 +898,32 @@ tls13_HandleKeyShare(sslSocket *ss,
 
     switch (entry->group->keaType) {
         case ssl_kea_ecdh_hybrid:
-            if (entry->group->name != ssl_grp_kem_xyber768d00 || entry->key_exchange.len < X25519_PUBLIC_KEY_BYTES) {
+            switch (entry->group->name) {
+                case ssl_grp_kem_mlkem768secp256r1:
+                    dhLen = SECP256_PUBLIC_KEY_BYTES;
+                    /* secp256 share is at the beginning */
+                    ec_data = entry->key_exchange.len < dhLen
+                                  ? NULL
+                                  : entry->key_exchange.data;
+                    dhGroup = ssl_LookupNamedGroup(ssl_grp_ec_secp256r1);
+                    break;
+                case ssl_grp_kem_mlkem768x25519:
+                    dhLen = X25519_PUBLIC_KEY_BYTES;
+                    /* x25519 share is at the end */
+                    ec_data = entry->key_exchange.len < dhLen
+                                  ? NULL
+                                  : entry->key_exchange.data + entry->key_exchange.len - dhLen;
+                    dhGroup = ssl_LookupNamedGroup(ssl_grp_ec_curve25519);
+                    break;
+                default:
+                    ec_data = NULL;
+                    break;
+            }
+            if (!ec_data) {
                 PORT_SetError(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
                 goto loser;
             }
-            rv = ssl_ImportECDHKeyShare(peerKey,
-                                        entry->key_exchange.data,
-                                        X25519_PUBLIC_KEY_BYTES,
-                                        ssl_LookupNamedGroup(ssl_grp_ec_curve25519));
+            rv = ssl_ImportECDHKeyShare(peerKey, ec_data, dhLen, dhGroup);
             mechanism = CKM_ECDH1_DERIVE;
             break;
         case ssl_kea_ecdh:
@@ -2665,10 +2792,19 @@ tls13_HandleClientKeyShare(sslSocket *ss
         if (rv != SECSuccess) {
             goto loser; /* Error set by tls13_HandleKEMKey */
         }
-        // We may need to handle different "combiners" here in the future. For
-        // now this is specific to xyber768d00.
-        PORT_Assert(peerShare->group->name == ssl_grp_kem_xyber768d00);
-        ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(dheSecret, kemSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+        switch (peerShare->group->name) {
+            case ssl_grp_kem_mlkem768secp256r1:
+                ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(dheSecret, kemSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+                break;
+            case ssl_grp_kem_mlkem768x25519:
+                ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(kemSecret, dheSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+                break;
+            default:
+                PORT_Assert(0);
+                PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+                ss->ssl3.hs.dheSecret = NULL;
+                break;
+        }
         if (!ss->ssl3.hs.dheSecret) {
             goto loser; /* Error set by PK11_ConcatSymKeys */
         }
@@ -3512,10 +3648,19 @@ tls13_HandleServerKeyShare(sslSocket *ss
         if (rv != SECSuccess) {
             goto loser; /* Error set by tls13_HandleKEMCiphertext */
         }
-        // We may need to handle different "combiners" here in the future. For
-        // now this is specific to xyber768d00.
-        PORT_Assert(entry->group->name == ssl_grp_kem_xyber768d00);
-        ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(dheSecret, kemSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+        switch (entry->group->name) {
+            case ssl_grp_kem_mlkem768secp256r1:
+                ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(dheSecret, kemSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+                break;
+            case ssl_grp_kem_mlkem768x25519:
+                ss->ssl3.hs.dheSecret = PK11_ConcatSymKeys(kemSecret, dheSecret, CKM_HKDF_DERIVE, CKA_DERIVE);
+                break;
+            default:
+                PORT_Assert(0);
+                PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+                ss->ssl3.hs.dheSecret = NULL;
+                break;
+        }
         if (!ss->ssl3.hs.dheSecret) {
             goto loser; /* Error set by PK11_ConcatSymKeys */
         }
